/**

 Copyright (c) 2010-2014  hkrn

 All rights reserved.

 Redistribution and use in source and binary forms, with or
 without modification, are permitted provided that the following
 conditions are met:

 - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
 - Redistributions in binary form must reproduce the above
   copyright notice, this list of conditions and the following
   disclaimer in the documentation and/or other materials provided
   with the distribution.
 - Neither the name of the MMDAI project team nor the names of
   its contributors may be used to endorse or promote products
   derived from this software without specific prior written
   permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.

*/

#include <QQuickItem>
#include <vpvl2/Common.h>

class ProjectProxy;

namespace vpvl2 {
namespace VPVL2_VERSION_NS {
class IModel;
}
using namespace VPVL2_VERSION_NS;
}

class Importer : public QQuickItem
{
    Q_OBJECT
    Q_PROPERTY(ProjectProxy *project MEMBER m_projectRef FINAL)
    Q_PROPERTY(QStringList nameFilters READ nameFilters CONSTANT FINAL)

public:
    Importer();
    ~Importer();

    Q_INVOKABLE void importModel(const QUrl &url);

    QStringList nameFilters() const;

signals:
    void modelBufferDidGenerate(const QByteArray &bytes);

private slots:
    void internalLoadModel(vpvl2::IModel *model, const QUrl &fileUrl, const QString errorString);

private:
    ProjectProxy *m_projectRef;
    QStringList m_nameFilters;
};
